<?php
define ( 'IN_MKP', 1 );
$MK_PATH = "../";
require $MK_PATH."mkportal/conf_mk.php";
if (!defined("IN_MKP")) {
    die ("Sorry !! You cannot access this file directly.");
}

switch($MK_BOARD) {
	case 'IPB':
		$driverf = "IPB/ipb_driverf.php";
		$board_functions = "IPB/ipb_board_functions.php";
    break;
	case 'PHPBB':
    	$driverf = "PHPBB/php_driverf.php";
		$board_functions = "PHPBB/php_board_functions.php";
    break;
//Meo: Added in C 0.1.c for Phpbb3 integration
	case 'PHPBB3':
    	$driverf = "PHPBB3/php_driverf.php";
		$board_functions = "PHPBB3/php_board_functions.php";
    break;
//End
	case 'VB':
    	$driverf = "VB/vb_driverf.php";
		$board_functions = "VB/vb_board_functions.php";
    break;
//Meo: Added in C 0.1 for AEF integration
	case 'AEF':
    	$driverf = "AEF/aef_driverf.php";
		$board_functions = "AEF/aef_board_functions.php";
    break;
//End
    case 'IPB13':
    		$driverf = "IPB13/ipb13_driverf.php";
		$board_functions = "IPB13/ipb13_board_functions.php";
    break;
	case 'MYBB':
    		$driverf = "MYBB/mybb_driverf.php";
		$board_functions = "MYBB/mybb_board_functions.php";
    break;
	default:
    	$driverf = "SMF/smf_driverf.php";
		$board_functions = "SMF/smf_board_functions.php";
    break;
}

require $MK_PATH."mkportal/include/$driverf";
require $MK_PATH."mkportal/include/functions.php";
require $MK_PATH."mkportal/include/$board_functions";
global $mkportals, $mklib, $Skin;
$lid=intval($_GET['lid']);


	$tmp_fname = "cache/$lid.gif";
	if(file_exists($tmp_fname)) {
		$itime=filemtime($tmp_fname);
		$itime=intval( $itime/86400 );
		$itnow=time();
		$itnow=intval( $itnow/86400 );
		
		if($itime == $itnow) {
			header('Location: '.$URL_METRIC.'cache/'.$lid.'.gif');
			exit();
		}
		else {
			@unlink($tmp_fname);
		}
	}

$query = $DB->query("SELECT * FROM metric_config");
while( $row = $DB->fetch_row($query) ) {
	$parname = $row['parname'];
	$parval = $row['parval'];
	$metconfig[$parname] = $parval;
}

//      $DB->query('set names utf8');
		$DB->query("SELECT * FROM metric_table WHERE id='$lid' LIMIT 1");
		$row = $DB->fetch_row();
	if (!$row) {
		$ban = "ban.gif";
		$ban = imagecreatefromgif($ban);
		header('Content-type: image/gif');
		imagegif($ban);
		exit;
	}
		$limg = ".".$row['irule'];
		$bimg = ".".$row['ibegun'];
		$uname = $row['uname'];
		list($iyear, $imon, $iday) = explode('-', $row['sdate']);
		$spodp = stripslashes($row['spodp']);
		$err = 0;
		$DB->query("UPDATE metric_table SET dtlastreq = NOW() WHERE id='$lid'");



	function dateDiff($iday, $imon, $iyear, $sw, $add_time = 0) {
		$fromtime = mktime(3, 0, 0, $imon, $iday, $iyear);
		$fromtime += $add_time;
		$totime = intval(time() / 86400) * 86400;
		
		if ($totime < $fromtime) {
			$tmp = $totime;
			$totime = $fromtime;
			$fromtime = $tmp;
			
			$iyear = date('Y', $fromtime);
			$imon = date('m', $fromtime);
			$iday = date('d', $fromtime);
		}
		
		$year_now = date('Y', $totime);
		$month_now = date('m', $totime);
		$day_now = date('d', $totime);
		
		$years = $year_now - $iyear;
		$mons = $month_now - $imon;
		$days = $day_now - $iday;
		
		if ($days < 0) {
			$imon = intval(date('m', $fromtime));
			$iyear = date('Y',$fromtime);
		
			$m = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
			if ((($iyear % 4 == 0) && ($iyear % 100 != 0)) || ($iyear % 400 == 0)) {
				$m[1] = 29;
			}
			$days += $m[ $imon - 1 ];
			$mons--;
		}
		if ($mons < 0) {
			$mons += 12;
			$years--;
		}
		
		$ret = array(
			'years' => $years
		);

		if ($sw == 1 && $mons < 10 && $years == 0)  {
			$days = intval(($totime - $fromtime) / 86400);
			$ret['months'] = 0;
			$ret['weeks'] = floor($days / 7);
			$ret['days'] = $days % 7;
			return $ret;
		}
		$ret['months'] = $mons;
		$ret['weeks'] = 0; //floor($days / 7);
		$ret['days'] = $days; // $days % 7;
	return $ret;
	}
	function getPeriod(&$date_diff) {
		$period = '';
		addPeriodItem($period, $date_diff['years'], 'лет|год|года');
		addPeriodItem($period, $date_diff['months'], 'месяцев|месяц|месяца');
		addPeriodItem($period, $date_diff['weeks'], 'недель|неделя|недели');
		addPeriodItem($period, $date_diff['days'], 'дней|день|дня');
		return $period;
	}
	function addPeriodItem(&$str, $count, $count_names) {
		if($count > 0) {
			if($str) $str.= ', ';
			$str.= $count.' '. getCountName($count, $count_names);
		}
	}

	function getCountName($count, $names) {
		$names = explode('|', $names);
		if (count($names)==2) {
			return $count==1 ? $names[1] : $names[0];
		}
		$count = intval($count) % 100;
		if ($count>=5 && $count<=20) $out = $names[0];
		else {
			$count_modulus = $count % 10;
			if ($count_modulus==1) $out = $names[1];
			elseif ($count_modulus < 5 && $count_modulus!=0) $out = $names[2];
			else $out = $names[0];
		}
		return $out;
	}

$limg = imagecreatefromgif($limg);
$bimg = imagecreatefromgif($bimg);
$lw = imagesx($limg); 
$lh = imagesy($limg); 
$bw = imagesx($bimg); 
$bh = imagesy($bimg);
if ($lh>$bh) { 
$h=$lh;
} 
else
{
$h=$bh;
}

$img = imagecreatetruecolor($lw,$h+$metconfig['fontsize']+2); 
imagefill($img, 0, 0, 0xFFFFFF);  
imagecolortransparent($img, imagecolorallocate($img, 255, 255, 255));
$textcolor=imagecolorallocate($img, base_convert(substr($metconfig['text_color'],0,2),16,10), base_convert(substr($metconfig['text_color'],2,2),16,10), base_convert(substr($metconfig['text_color'],4,2),16,10));
$font = "./ttf/{$metconfig['font']}.ttf";
	$rs = dateDiff($iday, $imon, $iyear, $metconfig['show_weeks']);
	$sdate = getPeriod($rs);
$scale=($lw-$bw)/365;
$bpos = intval(($rs[months] * 30 + $rs[weeks] * 7 + $rs[days])*$scale);

imagettftext($img, $metconfig['fontsize'], 0, 0, $h+$metconfig['fontsize'], $textcolor, $font, $spodp.' '.$sdate);


imagecopy($img,$limg,0,($h/2)-($lh/2),0,0,$lw,$lh); 
imagecopy($img,$bimg,$bpos,($h/2)-($bh/2),0,0,$bw,$bh); 


imagegif($img,"cache/$lid.gif");

header('Content-type: image/gif');
   imagegif($img);
   imageDestroy($limg);
   imageDestroy($bimg);

?>